From 7bc397cac0f58476b34d20c5d06d8313602071ab Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 12 2021 07:07:58 +0000
Subject: [PATCH 2111/2232] Remove this != &other checks from move assignment operators


---

diff --git a/include/cxx.h b/include/cxx.h
index b9749de..0744f8c 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -824,11 +824,9 @@ Vec<T>::~Vec() noexcept {
 
 template <typename T>
 Vec<T> &Vec<T>::operator=(Vec &&other) noexcept {
-  if (this != &other) {
-    this->drop();
-    this->repr = other.repr;
-    new (&other) Vec();
-  }
+  this->drop();
+  this->repr = other.repr;
+  new (&other) Vec();
   return *this;
 }
 
diff --git a/src/cxx.cc b/src/cxx.cc
index fd34e34..2e4e0a0 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -109,11 +109,9 @@ String &String::operator=(const String &other) noexcept {
 }
 
 String &String::operator=(String &&other) noexcept {
-  if (this != &other) {
-    cxxbridge1$string$drop(this);
-    this->repr = other.repr;
-    cxxbridge1$string$new(&other);
-  }
+  cxxbridge1$string$drop(this);
+  this->repr = other.repr;
+  cxxbridge1$string$new(&other);
   return *this;
 }
 
@@ -392,13 +390,11 @@ Error &Error::operator=(const Error &other) {
 }
 
 Error &Error::operator=(Error &&other) noexcept {
-  if (this != &other) {
-    std::exception::operator=(std::move(other));
-    this->msg = other.msg;
-    this->len = other.len;
-    other.msg = nullptr;
-    other.len = 0;
-  }
+  std::exception::operator=(std::move(other));
+  this->msg = other.msg;
+  this->len = other.len;
+  other.msg = nullptr;
+  other.len = 0;
   return *this;
 }
 

